package SESS;
############################################################################
##                                                                        ##
##	A Product of CoreUnix.com, Form Submission for CTS1.1             ##
##                                                                        ##
##                                                                        ##
########################## license & copyright header ######################
##                                                                        ##
##    This program has been tested to work both as a CGI script. 	  ##
##                                                                        ##
##                                                                        ##
##                    Copyright (c) 2003 by Sri Penumetcha                ##
##                                                                        ##
##      This program is proprietary software; it is intended only for     ##
##      the  customer's internal use. It is the responsibility of the     ##
##      customer to see to it that it is not used to any illegal          ##
##      cause.  The author has no responsibility what so ever to any      ##
##      damage to property or legal laws caused by this software once     ##
##      it has been out of the authors ownership.                         ##
##                                                                        ##
##      This program is developed in the hope that it will be useful,     ##
##      but WITHOUT ANY WARRANTY; without even the implied warranty of    ##
##      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     ##
##      Agreement.html for more details.                                  ##
##                                                                        ##
##      You should have received a copy of the Agreement.html as well as  ##
##      a copy of License.html with this program, if not, send a request  ##
##      to the below mentioned author(s).                                 ##
##                                                                        ##
##                         CoreUnix.com <srikanth@coreunix.com>           ##
##                                <http://www.coreunix.com/license.html>  ##
##                                                                        ##
######################## end license & copyright header ####################

# This module deals with the session_id, username, passwd, Trip Type, From City,
# To City, Dep Date, Ret Date, Adults, Children, Infrants, Airlines, Comments,
# Contact Name, Email, Day Number, Evening Number Database to handle
# Sessions.
# Requires RPM perl-Digest-MD5-2.16-15
# Requires RPM perl-DBI-1.21-1


require Exporter;
use vars qw(@ISA @EXPORT @VERSION);
@ISA = qw(Exporter);
@EXPORT = qw(save_state get_state get_session_id initialize);

use strict;
use CGI qw/ :standard /;
use DBI;
#use Digest::MD5 ();


# session settings
use constant EXPIRE => 60*60*24*30;  # Allow 30 days before expiration;
use constant DB => 'dbi:Pg:dbname=CUSCTS';
use constant DBAUTH => 'apache:';
use constant SECRET => 'modperl reigns';
our ($DBH, $DB_TABLE, $ID_LENGTH);
$ID_LENGTH  =  8;               #Length of the session ID.
$DB_TABLE  =  'sesscts';        #Database for handling customer sessions.

use constant MAX_TRIES => 10;
my $DEBUG = 0;

# Open the database
$DBH = DBI->connect(DB, split(':',DBAUTH,2), {PrintError=>0})
        || die "Couldn't open database: ", $DBI::errstr;

# Retrieve the session ID from the path info. If it's not
# already there, ad it to the path info with a redirect.
######################################################
sub get_session_id {
# This routine is used to generate a session id
######################################################
        my(@result);
	my $sessionid = param('sessionid');
	my $cus_filelnk = param('cus_filelnk');
if( $DEBUG ) {
        open( DBUG, ">>hangdb.log") || die "Can't open log file: $!\n";
        print DBUG "In get_session_id sub\n";
        close(DBUG);
}
#       expire_old_sessions();
#        my($id) = path_info() =~ m:^/([a-h0-9]{$ID_LENGTH}):o;
        my($id) = $sessionid;
	my $URL = url();
	my $PTI = path_info();
if( $DEBUG ) {
        open( DBUG, ">>hangdb.log") || die "Can't open log file: $!\n";
        print DBUG "Before redirct path_info  and id : $PTI -- $id \n";
        close(DBUG);
}
        return @result if $id and @result = check_id($id);
if( $DEBUG ) {
        open( DBUG, ">>hangdb.log") || die "Can't open log file: $!\n";
        print DBUG "After getting Arr result  and id : @result -- $id -- \n";
        close(DBUG);
}

        # If we get here, there's not an ID in the path info.
        $sessionid = generate_id();
        die "Couldn't make a new session id" unless $sessionid;

	my $scriptame = script_name();
if( $DEBUG ) {
        open( DBUG, ">>hangdb.log") || die "Can't open log file: $!\n";
        print DBUG "Before redirct script_name -- session_id: $scriptame -- $sessionid\n";
        close(DBUG);
}
        print redirect(script_name() . "?sessionid=$sessionid&cus_filelnk=$cus_filelnk");
#        print redirect(path_info() . "?sessionid=$sessionid&cus_filelnk=$cus_filelnk");
        exit 0;
}

######################################################
sub initialize {
# This routine is used to initialize all values
######################################################
        my $state = shift;
if( $DEBUG ) {
        open( DBUG, ">>hangdb.log") || die "Can't open log file: $!\n";
        print DBUG "In initialize sub\n";
        close(DBUG);
}
        $state = {} unless $state;
        $state->{contfld}        = '';
        $state->{emailfld}       = '';
        $state->{daynofld}       = '';
        $state->{evenumfld}      = '';
        return $state;
}

######################################################
sub generate_id {
# Find a new unique ID and insert it into the database
######################################################
        my $tries = 0;
if( $DEBUG ) {
        open( DBUG, ">>hangdb.log") || die "Can't open log file: $!\n";
        print DBUG "In generate_id sub\n";
        close(DBUG);
}
#        my $id = hash(SECRET . rand());
        my $id = time;
        while( $tries++ < MAX_TRIES) {
                last if $DBH->do("INSERT INTO $DB_TABLE (session_id,modified) VALUES ('$id','now')");
#                $id = hash(SECRET . $id);
		my $dig = sprintf("%d",(rand() * 1000));
                $id = $id . $dig;
        }
        return undef if $tries >= MAX_TRIES; # we failed
        return $id;
}

######################################################
sub check_id {
# Check to see if that an old ID is valid.
######################################################
        my $id = shift;
if( $DEBUG ) {
        open( DBUG, ">>hangdb.log") || die "Can't open log file: $!\n";
        print DBUG "In check_id sub with id: $id\n";
        close(DBUG);
}
        return($id, '')
                if $DBH->do("SELECT 1 FROM $DB_TABLE WHERE session_id='$id'") > 0;
if( $DEBUG ) {
        open( DBUG, ">>hangdb.log") || die "Can't open log file: $!\n";
        print DBUG "In check_id sub entering new id into DB\n";
        close(DBUG);
}
        return($id, 'The record of your game may have expired. Restarting.')
                if $DBH->do("INSERT INTO $DB_TABLE (session_id,modified) VALUES ('$id','now')");
        return ();
}


######################################################
sub hash {
# Generate a hash value.
######################################################
        my $value = shift;
if( $DEBUG ) {
        open( DBUG, ">>hangdb.log") || die "Can't open log file: $!\n";
        print DBUG "In hash sub with value : $value - \n";
        close(DBUG);
}
#        return substr(Digest::MD5::md5_hex($value), 0, $ID_LENGTH);
}

######################################################
sub expire_old_sessions {
# This routine is used to delete old session ids
######################################################
if( $DEBUG ) {
        open( DBUG, ">>hangdb.log") || die "Can't open log file: $!\n";
        print DBUG "In expire_old_sesions sub\n";
        close(DBUG);
}
        $DBH->do("DELETE FROM $DB_TABLE WHERE ".
                "(unix_timestamp() - unix_timestamp(modified))>${\EXPIRE}");
}

######################################################
sub get_state {
# This routine is used to retrieve an existing state.
######################################################
        my $id = shift;
if( $DEBUG ) {
        open( DBUG, ">>hangdb.log") || die "Can't open log file: $!\n";
        print DBUG "In get_state sub with id : $id\n";
        close(DBUG);
}
        my $sth = $DBH->prepare("SELECT * FROM $DB_TABLE WHERE session_id='$id'")
                || die "Prepare: ", $DBH->errstr;
        $sth->execute || die "Execute: ", $sth->errstr;
        my $state = $sth->fetchrow_hashref;
if( $DEBUG ) {
        open( DBUG, ">>hangdb.log") || die "Can't open log file: $!\n";
        print DBUG "In get_state sub with state info as: \n";
        print DBUG "$state->{session_id} $state->{userid} $state->{passwd} $state->{modified}\n";
        close(DBUG);
}
        $sth->finish;
        return $state;
}


######################################################
sub save_state {
# This routine is used to save the current state.
######################################################
        my($state, $id) = @_;
if( $DEBUG ) {
        open( DBUG, ">>hangdb.log") || die "Can't open log file: $!\n";
        print DBUG "In save_state sub with id : $id\n";
        print DBUG "In save_state sub with values : $state->{userid}, $state->{passwd}\n";
        close(DBUG);
}
        my $sth = $DBH->prepare("UPDATE $DB_TABLE SET userid=?, passwd=?, ".
		"  modified='now'  WHERE session_id='$id'");

        $sth->execute(@{$state}{qw(userid passwd)}) || die "execute: ", $DBH->errstr;
        $sth->finish;
}
1;
